
#include <stdio.h>
#include <stdlib.h>
#include "eventi.h"

int leggiSingoloEvento(FILE *fp, Evento* e){
	int res;
	res = fscanf(fp, "%10c%d/%d/%d\n", (*e).nome, &(*e).inizio.giorno, &(*e).inizio.mese, &(*e).inizio.anno);
	e->nome[10]='\0';
	return res;
}

int scriviSingoloEvento(FILE *fp, Evento e){
	return fprintf(fp, "%s%d/%d/%d\n", e.nome, e.inizio.giorno, e.inizio.mese, e.inizio.anno);
}

// Esercizio 1
int comparazione(Evento e1, Evento e2){
	if(e1.inizio.anno < e2.inizio.anno){
		return -1;
	}
	else if (e1.inizio.anno == e2.inizio.anno){
		if (e1.inizio.mese < e2.inizio.mese){
			return -1;
		}
		else if (e1.inizio.mese == e2.inizio.mese){
			if (e1.inizio.giorno < e2.inizio.giorno){
				return -1;
			}
			else if (e1.inizio.giorno == e2.inizio.giorno){
				return 0;
			}
		}
	}
	return +1;
}

// Esercizio 2
void merge(char* file1, char* file2, char* fileout){
	FILE *f1, *f2, *fo;
	Evento e1, e2;
	int res1, res2, comp;
		
    f1=fopen(file1,"rt");
    if(f1==NULL) exit(-1);
	
	f2=fopen(file2,"rt");
    if(f2==NULL) exit(-1);

	fo=fopen(fileout,"wt");
    if(fo==NULL) exit(-1);
	
	res1=leggiSingoloEvento(f1, &e1);
	res2=leggiSingoloEvento(f2, &e2);
    
	while(res1==4||res2==4){
		if(res1!=4 && res2==4){
			scriviSingoloEvento(fo, e2);
			res2=leggiSingoloEvento(f2, &e2);
		}
		else if(res1==4 && res2!=4){
			scriviSingoloEvento(fo, e1);
			res1=leggiSingoloEvento(f1, &e1);
		}
		else{
			comp=comparazione(e1, e2);
			if(comp==-1){
				scriviSingoloEvento(fo, e1);
				res1=leggiSingoloEvento(f1, &e1);
			}
			else{
				scriviSingoloEvento(fo, e2);
				res2=leggiSingoloEvento(f2, &e2);
			}
		}
	}

	fclose(f1);
	fclose(f2);
	fclose(fo);
}

// Esercizio 3
list eventiLista(char* nomefile, Data start, Data end){
	list l;
	FILE *fd;
	Evento e, e_start, e_end;
	int res;
	e_start.inizio=start;
	e_end.inizio=end;
	
	fd=fopen(nomefile,"rt");
    if(fd==NULL) exit(-1);
	
	l=emptylist();
	res=leggiSingoloEvento(fd, &e);
    while(res==4){
		if( comparazione(e,e_start)==1 && comparazione(e,e_end)==-1 ){
			l=cons(e,l);
		}
		res=leggiSingoloEvento(fd, &e);
		if( comparazione(e,e_end)==1 ){
			res=-1;
		}
	}

	return l;
}

// Esercizio 4
list eliminazione(list l){
	if(empty(l)) return l;
	if(empty(tail(l))) return l;
	else if( comparazione( head(l), head(tail(l)) ) ==0 )
		return eliminazione(tail(l));
	else 
		return cons( head(l), eliminazione(tail(l)) );
}

// Esercizio 5
Evento* trasforma(list l, int *dim){
	Evento* res;
	list temp;
	(*dim)=0;
	
	temp=l;
	while(!empty(temp)){
		(*dim)++;
		temp=tail(temp);
	}

	res=(Evento*)malloc((*dim)+sizeof(Evento));
	
	(*dim)=0;
	while(!empty(l)){
		res[*dim]=head(l);
		l=tail(l);
		(*dim)++;
	}

	return res;
}
